require("Turtle")
Wheat = Turtle:new()

function Wheat:getStatusDown()
    local bd, data = turtle.inspectDown()
    if(bd == true) then
        if(data.state.age == nil) then
            return -1
        end
        return data.state.age
    end
    if(turtle.digDown() == true) then
        return -2
    end
    if(self:selectPlantable(true)) then
        if(turtle.placeDown() == true) then
            turtle.digDown()
            return -2
        end
        return -1
    end
    return false
end

function Wheat:isPlantable(slot, update)
    self:assertInvUpdate(update)
    if(type(self.inv[slot]) ~= "table") then
        return false
    end
    if(type(self.inv[slot].tags) ~= "table") then
        return false
    end
    return self.inv[slot].tags["forge:seeds"] == true
end

function Wheat:getPlantable(update)
    self:assertInvUpdate(update)
    for i = 1, 16 do
        if(self:isPlantable(i, false)) then
            return i
        end
    end
    return false
end

function Wheat:selectPlantable(update)
    self:assertInvUpdate(update)
    local slot = self:getPlantable(false)
    if(slot == false) then
        return false
    else
        turtle.select(slot)
        return true
    end
end